#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Jun 14 15:32:28 2019

@author: pierrels
"""

import matplotlib.pyplot as plt
import numpy as np
from matplotlib import animation
from matplotlib import pyplot as plt
import time


L = 1

l = 0.3

T = 100

def main(n_t, n_L):
    
    dx = L / n_L
    dt = T / n_t
    
    n_L += 1
    n_t += 1
    
    Z_theorique = np.zeros((n_t, n_L))
    
    for n in range(n_t):
        Z_theorique[n] = (np.sin((np.arange(0,n_L) * dx - n*dt) * np.pi/(2*L)) + np.sin((np.arange(0,n_L)*dx + n*dt) * np.pi/(2*L))) / 2
    
    u_init = 3 * np.sin(np.arange(0, n_L)*dx * np.pi / (2*L))
    v_init = np.ones(n_L) * 0
    
    Z = np.zeros((n_t, n_L))
    Z[0,:] = u_init
    Z[1,:] = u_init + dt * v_init
    
    
    A = np.eye(n_L) * (2 - dt**2 / dx**2 * 2)
    A[-1,-1] = 2 - dt**2/dx**2
    for k in range(n_L-1):
        A[k,k+1] = dt**2/dx**2
        A[k+1,k] = dt**2/dx**2
    
    tab = np.ones(n_L) * 0
    tab[0] = 0
    #tab[-1] = 0
    
    def f(u):
        return tab
    
    def ondes(n):
        Z[n] = A.dot(Z[n-1]) - Z[n-2] + dt**2 * f(Z[n-1])
        Z[n,0] = 0
    #    Z[n,-1] = 0
        Z[n,n_l] = max(Z[n,n_l], 0)
    
    for n in range(2,n_t):
    #    print("t = {}".format(n*dt))
        ondes(n)
    
    return Z
#    print (dt**2 / dx**2, n_t, n_L)
#    return np.max(np.linalg.norm((Z_theorique - Z), ord = 2, axis = 1)) * np.sqrt(dx)


#Z, Z_theorique = main(100,100)

#t = []
#
#for k in range(2,500):
#    t.append(main(k,k))
#
#t = np.array(t)
#
#plt.plot(t * np.arange(2,500))
#
##x = [1 / (main(100, k)) for k in np.arange(400,500)]
#
#

n_L = 200
n_t = 20000
n_l = int(l * n_L / L)

dx = L / n_L
dt = T / n_t

X = np.arange(0,L+dx, dx)
Z = main(n_t,n_L)

fps = 30
ratio_vitesse = 1

fig, ax = plt.subplots()
ligne, = ax.plot([0,L],[-5,5])
txt = ax.text(0, 1, "t = {}".format(int(0)/10))

#ax.plot(X,Z[0,:])
ax.plot([n_l*dx, n_l*dx], [-5,0])

def animate(i):
    ligne.set_data(X, Z[int(i * n_t / (fps * T)),:])
#    ligne.set_data(X, abs(Z[int(i * n_t / (30 * T)),:] - Z[0,:]))
    txt.set_text("t = {}".format(int(int(i * n_t / (fps * T)) * dt * 10)/10))
#    if i == 0:
#        plt.plot(X,Z[0,:])

ani = animation.FuncAnimation(fig, animate, frames=int(fps*T), interval=1000/(fps*ratio_vitesse))

Writer = animation.writers['ffmpeg']
writer = Writer(fps=15, metadata=dict(artist='Me'), bitrate=1800)
ani.save('im.mp4', writer=writer)

plt.show()