#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Jun 18 14:26:15 2019

@author: pierrels
"""

import matplotlib.pyplot as plt
import numpy as np
from matplotlib import animation
import time

temps = time.time()

L = 2
n_L = 50

l = 1

T = 10
n_t = 100000

eps = 1
dx = L / n_L
dt = T / n_t
n_l = int(l/dx)

u_init = np.ones(n_L) + np.sin(np.arange(0,2*np.pi,2*np.pi/n_L))
v_init = np.arange(n_L) / n_L

Z = np.zeros((n_t, n_L*2))
Z[0,:] = np.concatenate((u_init, v_init))


def neg(x):
    return max(-x,0)

A = np.eye(2*n_L)
for k in range(n_L):
    A[k, k + n_L] = dt
    A[k + n_L, k] = + 2 * dt / dx**2
for k in range(n_L-1):
    A[k + n_L, k + 1] = -dt / dx**2
    A[k+1 + n_L, k] = -dt / dx**2
A[0,n_L] = 0
A[n_L-1, 2*n_L-1] = 0


temp = np.zeros(2*n_L)
temp[n_L + n_l] = 1

def f(n,u):
    return 0 * temp * neg(u[n_l])/eps - 5

def ondes(n):
    Z[n] = A.dot(Z[n-1]) + dt * f(n,Z[n-1])
    Z[n,0] = Z[n-1,0]
    Z[n,n_L-1] = Z[n-1,n_L-1]

for n in range(1,n_t):
    ondes(n)
    print("t = {}".format(n*dt))

print("done")

X = np.arange(0,L,dx)

fig, ax = plt.subplots()
ligne, = ax.plot([0,2],[-5,5])

def animate(n):
    ligne.set_data(X, Z[n,:n_L])

ani = animation.FuncAnimation(fig, animate, frames=n_t, interval=1000*dt)

#Writer = animation.writers['ffmpeg']
#writer = Writer(fps=15, metadata=dict(artist='Me'), bitrate=1800)
#ani.save('im.mp4', writer=writer)

plt.show()